export function getBorderRadius() {
    let borderRadius = window.getComputedStyle(document.documentElement).getPropertyValue("--hy-element-border-radius");
    if (borderRadius.includes("rem")) borderRadius = remToPx(borderRadius); // Convert rem to px
    borderRadius = parseFloat(borderRadius); // Convert to number

    if (isNaN(borderRadius)) borderRadius = 10; // Default value if not set
    if (borderRadius < 0) borderRadius = 10; // Default value if negative

    return borderRadius;
}

function remToPx(remValue) {
    const rootFontSize = parseFloat(getComputedStyle(document.documentElement).fontSize);
    return remValue * rootFontSize;
}
