export default function querySelectorAsync(selector) {
    return new Promise((resolve) => {
        // If the element already exists, return it immediately
        if (document.querySelector(selector)) {
            return resolve(document.querySelector(selector));
        }

        // Otherwise, wait for the element to be added to the DOM
        const observer = new MutationObserver(() => {
            if (document.querySelector(selector)) {
                observer.disconnect();
                resolve(document.querySelector(selector));
            }
        });

        // If you get "parameter 1 is not of type 'Node'" error, see https://stackoverflow.com/a/77855838/492336
        observer.observe(document.body, {
            childList: true,
            subtree: true,
        });
    });
}
